/*
 * Copyright (C) 2001-2006 The Mir-coders group
 *
 * This file is part of Mir.
 *
 * Mir is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Mir is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Mir; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * In addition, as a special exception, The Mir-coders gives permission to link
 * the code of this program with  any library licensed under the Apache Software License,
 * and distribute linked combinations including the two.  You must obey the
 * GNU General Public License in all respects for all of the code used other than
 * the above mentioned libraries.  If you modify this file, you may extend this
 * exception to your version of the file, but you are not obligated to do so.
 * If you do not wish to do so, delete this exception statement from your version.
 */
package mir.storage.store;

import mir.entity.StorableObjectEntity;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public final class StoreUtil {

	private final static Class    storableObjectInterface=StorableObject.class;

  // avoid construction
  private StoreUtil() { }


  public static final String getPropNameFor(Class aClass) {
    if ( aClass!=null ) {
      String className=aClass.toString();
      return className.substring(className.lastIndexOf(".")+1);
    }
    return null;
  }

  public static final String getEntityListUniqueIdentifierFor( String table,
    String where, String order, int offset, int limit)
  {
    StringBuffer sb = new StringBuffer(table);
    sb.append("@");
    if ( where!=null ) sb.append(where);
    sb.append("@");
    if ( order!=null ) sb.append(order);
    sb.append("@").append(offset);
    sb.append("@").append(limit);
    return sb.toString();
  }

  /**
   * Description:  internall helper method to find out if a class extends
   * class StorableEntity.
   *
   * @param aClass DOCUMENT ME!
   *
   * @return true if yes, otherwise no.
   */
  public static final boolean extendsStorableEntity(Class aClass) {
    return StorableObjectEntity.class.isAssignableFrom(aClass);
  }


}